PLM之家PLMHome

[原创视频] PLM之家-NX9.0 二次开发实例视频33 NXOpen C++创建旋转特征

2014-5-5 18:55:37 18430 86

  [复制链接]
admin 发表于 2014-2-27 21:06:17 |阅读模式

admin 楼主

2014-2-27 21:06:17

请使用QQ关联注册PLM之家,学习更多关于内容,更多精彩原创视频供你学习!

您需要 登录 才可以下载或查看,没有帐号?注册

x
PLM之家-NX9.0 二次开发实例视频33 NXOpen C++创建旋转特征

旋转草图

旋转草图
" C) X1 R# i1 Z
8 f% e& X' E% `/ A4 k( }# w- ~
内容:  p9 `! P' \$ ^5 ^( l
通过草图创建旋转操作
! p  r/ n. X! C, \0 @- q目的:

$ x* S# h' N! I6 n2 g  t在NX中,使用NXOpen C++可以很方便的进行JA的录制,草图的旋转可以通过JA生成代码,此处旋转草图的轴通过界面选取,可以设置旋转的角度。代码需要显式设定公差选项SetTolerance(0.001)+ w* d5 y; T. z/ }' l1 D

% q( ]! v8 }; c! U" A: R/ ~6 ]
, u# F: E3 d) [ PLM之家-NX9.0二次开发实例33 NXOpen C++创建旋转草图(1)创建项目
$ p2 i" Z5 n6 R- U' k PLM之家-NX9.0二次开发实例33 NXOpen C++创建旋转草图(2)代码分析
6 W6 y2 y6 V8 `, o PLM之家-NX9.0二次开发实例33 NXOpen C++创建旋转草图(3)截面代码定义
# \0 N0 H8 M! t1 a/ [ PLM之家-NX9.0二次开发实例33 NXOpen C++创建旋转草图(4)UI关联
5 h% a  ?) ]9 o) F
/ E) h: Z6 k+ s/ T
关键代码分享:

& M; Y9 B) K0 @# E; s

; o# A0 c+ o' Bvoid lesson33_createRevolve::createRevolve(SkeTCh *sketch)4 O: p  d3 K  e( P" W. ?
{
( z8 c4 I% ?7 b/ l6 o6 D3 |) l$ Y Features::Feature *nullFeatures_Feature(NULL);* Z8 h3 f$ y4 @: v6 ]

' Z4 M6 O! G% P& c    Features::RevolveBuilder *revolveBuilder1;
! d. a3 _4 Y0 D    revolveBuilder1 = workPart->Features()->CreateRevolveBuilder(nullFeatures_Feature);" U+ J/ ^3 l' S, i  _- T
revolveBuilder1->SetTolerance(0.001);
) i, w* L7 I0 T3 u& Y% J$ E% `    Section *section1;' Y0 g9 m1 M2 Q/ F& `) S' ~
    section1 = workPart->Sections()->CreateSection(0.00095, 0.001, 0.05);
! }* w% j# K: d( n$ w% m- d    revolveBuilder1->SetSection(section1);
! B4 v" t' G% ^9 p" R8 n) W3 r    std::vector<Features::Feature *> features1(1);
# p% m4 H! }0 _5 M# s/ x1 J; Xfeatures1[0] = sketch->Feature();& t7 N& N! \: @$ q, i- t
    CurveFeatureRule *curveFeatureRule1;
- Q& i2 p5 q& Q% l1 h, |    curveFeatureRule1 = workPart->ScRuleFactory()->CreateRuleCurveFeature(features1);
& g& ~. P8 z2 M3 h. B$ W: o; i- i! h    std::vector<SelectionIntentRule *> rules1(1);
; Z9 n& ^: l+ N7 \! r    rules1[0] = curveFeatureRule1;( r/ r( Y$ I2 X& k* P. o
    NXObject *nullNXObject(NULL);
% I' F2 j2 W# _8 b1 o: w; z    Point3d helpPoint1(0, 0, 0);7 H0 o0 h+ J- C
    section1->AddToSection(rules1, nullNXObject, nullNXObject, nullNXObject, helpPoint1, Section::ModeCreate, false);
1 k- [( g8 _; {$ e+ B9 B' b    revolveBuilder1->SetSection(section1);
+ ^; ^' d8 A, O/ \8 l// get UI value; ?& J( o6 N8 ^; Q
vector<TaggedObject*> selectedObjects = this->axis0->GetProperties()->GetTaggedObjectVector("SelectedObjects");5 e& u4 {5 B6 c$ M; c0 d( |& w
Axis *axis1 = dynamic_cast<Axis *>(selectedObjects[0]);' ]+ v( \/ B  i% [% _$ Q. v5 p  ]
revolveBuilder1->SetAxis(axis1);
" V+ H& w+ c7 [1 f+ B# j( J: `double startValue = this->expStartAngle->GetProperties()->GetDouble("Value");
6 z1 ]8 W; v+ [3 B: P5 odouble endValue = this->expStartAngle1->GetProperties()->GetDouble("Value");
2 \% I7 j  h; b1 A3 F' m stringstream s_startValue,s_endValue;
5 _9 Z5 A% P4 X* m! w s_startValue <<startValue;8 A* E) T8 [1 D' c, D) i
s_endValue <<endValue;; I5 x, L6 v$ [. ~, r, J! `
revolveBuilder1->Limits()->StartExtend()->Value()->SetRightHandSide(s_startValue.str());- t8 G$ x% {9 K5 K/ K
revolveBuilder1->Limits()->EndExtend()->Value()->SetRightHandSide(s_endValue.str());$ K6 F/ j# r! ^0 k0 U1 }
    Features::Feature *feature1;
' b7 V6 Y$ G% s7 G    feature1 = revolveBuilder1->CommitFeature();  N) R, E6 h" U( g0 I
revolveBuilder1->Destroy();
4 n0 I4 n; t$ a/ ]section1->Destroy();
& s$ D" X5 ^7 o# L4 G; P}; p" F+ A: s0 R' ?' w2 q! u
; Y6 {7 N2 K+ I7 x& n
$ y6 b  l$ U1 x5 R! w- h
9 |/ g' Y5 t0 _3 v1 i* q7 |

+ m- H1 m) y5 ]8 f* f! K0 ?
! V6 U8 `; j7 D% M# H8 b

- b5 s5 l- i& m) m2 h9 U+ j/ H- t. N* A; {

% w  K% f* ~3 R0 Z
% b9 Y& r3 n: u- {' K6 Y
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复

使用道具 举报

全部回复86

admin 发表于 2014-2-27 21:06:24

admin 沙发

2014-2-27 21:06:24

# [2 M% Y6 J/ g" U* `# l* H1 i% { 6 l# c5 `# N7 Q0 ^2 J! a # ?8 }# I6 A5 W+ }/ g5 h PLM之家NX9.0二次开发视频教程 33 NXOpen C++创建旋转草图(1)创建项目 - |+ K/ E* c0 Z# D% A. |) { 5 e% Y. p5 @1 S2 E7 K, D2 f& R7 T7 ~( I6 s- F& N4 v# P - F% K* a' S, h 1 H( _7 ~7 A$ S , h; f7 s5 k( i7 U2 B # u% Q7 _, ~) x) ^PLM之家NX9.0二次开发视频教程 33 NXOpen C++创建旋转草图(2)代码分析& |1 d4 b k( `* V9 A7 @ 1 r- C M# H) a3 W# Q& u' H% @. R2 |; P' F : i7 R/ `7 m" W, ?3 p 4 u3 ~( I& v* M" K # g* ~) x: Z5 Q3 T4 FPLM之家NX9.0二次开发视频教程 33 NXOpen C++创建旋转草图(3)截面代码定义* `6 }9 h. U7 `. Y/ c / a/ P3 T# X( F. O: z- y& a) s 2 y" d! _: K; d; Z# E9 z; J& z" v% p1 `' C3 U% p : c, u2 {0 W) v9 X( s. Q: kPLM之家NX9.0二次开发视频教程 33 NXOpen C++创建旋转草图(4)UI关联 % |: d7 O6 H" T7 r Y1 | 5 P N! w0 h2 [ x8 Q) ^# H, N 3 L0 g7 H h; P" ]; v: S) }+ d: m# e6 l6 ` 3 i8 ^2 T$ |. v! K
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

shesng 发表于 2014-3-17 20:19:51

shesng 板凳

2014-3-17 20:19:51

看看想想,学习学习
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

静水康桥 发表于 2014-4-13 12:43:38

静水康桥 地板

2014-4-13 12:43:38

好好学习天天向上
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

☠寶∞爺☠ 发表于 2014-4-21 11:34:03

☠寶∞爺☠ 6#

2014-4-21 11:34:03

谢谢老大了,学习了!
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

等待花开 发表于 2014-4-22 10:51:19

等待花开 7#

2014-4-22 10:51:19

在找35的视频....
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

东沟恋君 发表于 2014-4-23 19:20:24

东沟恋君 8#

2014-4-23 19:20:24

好视频,顶起来
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

★害虫★ 发表于 2014-5-5 18:55:37

★害虫★ 10#

2014-5-5 18:55:37

正在学习中,谢谢。: H7 H; M7 ^- z
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复 支持 反对

使用道具 举报

发表回复

您需要登录后才可以回帖 登录 | 注册

返回列表 本版积分规则

用户组 : 管理员
邮   箱 :xduniverse@qq.com
手   机 :VIP用户可查看[申请]
Q   Q : 点击这里给我发消息
性别 : 就不告诉你
主页 :http://www.plmhome.com
个人介绍 :原西门子NX高级教务员,10多年NX培训,开发咨询,Teamcenter培训实施等

主题2237

帖子3470

积分65899

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 6 实现打开PLM之家

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 5 创建Tecnomatix

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 4 设置图标效果如

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 3 第一个hello plm

  • 官方文档,NX12 使用

    官方文档,NX12 使用 Python进行二次开发相关配

  • 关闭

    站长推荐上一条 /1 下一条

  • 发布新帖
  • 在线客服1
  • 在线客服2
  • 微信
  • 客户端
  • 返回顶部